Subject: bug#27668: 26.0.50; Crash with display-line-numbers t

From: Robert Pluim <[email-masked]>
Date: Thu, 13 Jul 2017 18:33:08 +0200

Eli Zaretskii <[email-masked]> writes:

>> From: Robert Pluim <[email-masked]>
>> Date: Thu, 13 Jul 2017 10:28:42 +0200
>> It's always approximately twice the correct one. In the two cases I
>> have so far it's 67:138 and 47:98. That's a ratio of n:(2n + 4) in
>> both cases.
>
> It's nice that a clear pattern emerges, but I still cannot see how
> that could happen...
>
> I think next thing to try is to see where does the used[1] count
> becomes too large.  I suggest to run Emacs under GDB with the
> following breakpoint on a line immediately after the call to
> PRODUCE_GLYPHS in display_line:
>
>   (gdb) break xdisp.c:21374 if it->glyph_row->used[1] > 90
>

OK, I can try that.

> This assumes that you're windows are never wider than 90 columns; if
> that's not true, enlarge the number as needed to prevent the
> breakpoint from breaking in legitimate cases.  When this breaks,
> please show the backtrace.
>
> Another idea is to set the following breakpoint inside
> maybe_produce_line_number:
>
>   (gdb) break xdisp.c:21010 if it->glyph_row != 0 && it->glyph_row->used[1] > 0
>
> Line 21010 is this:
>
>   short *u = it->glyph_row ? &it->glyph_row->used[TEXT_AREA] : NULL;
>
> There's a hidden assumption in the code that maybe_produce_line_number
> is called when no glyphs were produced for the screen line yet.  Maybe
> that assumption is wrong.
>

I'll try that if method 1 doesn't get me anywhere.

> Btw, what version of GCC do you use?

It's the standard system gcc for Ubuntu 16.04:

$ gcc -v
Using built-in specs.
COLLECT_GCC=gcc
COLLECT_LTO_WRAPPER=/usr/lib/gcc/x86_64-linux-gnu/5/lto-wrapper
Target: x86_64-linux-gnu
Configured with: ../src/configure -v --with-pkgversion='Ubuntu 5.4.0-6ubuntu1~16.04.4' --with-bugurl=file:///usr/share/doc/gcc-5/README.Bugs --enable-languages=c,ada,c++,java,go,d,fortran,objc,obj-c++ --prefix=/usr --program-suffix=-5 --enable-shared --enable-linker-build-id --libexecdir=/usr/lib --without-included-gettext --enable-threads=posix --libdir=/usr/lib --enable-nls --with-sysroot=/ --enable-clocale=gnu --enable-libstdcxx-debug --enable-libstdcxx-time=yes --with-default-libstdcxx-abi=new --enable-gnu-unique-object --disable-vtable-verify --enable-libmpx --enable-plugin --with-system-zlib --disable-browser-plugin --enable-java-awt=gtk --enable-gtk-cairo --with-java-home=/usr/lib/jvm/java-1.5.0-gcj-5-amd64/jre --enable-java-home --with-jvm-root-dir=/usr/lib/jvm/java-1.5.0-gcj-5-amd64 --with-jvm-jar-dir=/usr/lib/jvm-exports/java-1.5.0-gcj-5-amd64 --with-arch-directory=amd64 --with-ecj-jar=/usr/share/java/eclipse-ecj.jar --enable-objc-gc --enable-multiarch --disable-werror --with-arch-32=i686 --with-abi=m64 --with-multilib-list=m32,m64,mx32 --enable-multilib --with-tune=generic --enable-checking=release --build=x86_64-linux-gnu --host=x86_64-linux-gnu --target=x86_64-linux-gnu
Thread model: posix
gcc version 5.4.0 20160609 (Ubuntu 5.4.0-6ubuntu1~16.04.4)